	subroutine SaveXx (imod,exitCode)
	implicit integer (a-z)
c++
c	subroutine SaveAll
c
c  Writes out or reads in descriptions of Optical System
c  in parts or whole
c
c  iMod		- input/integer
c		  verb modifier
c		    1 => save all
c		    2 => save oe
c		    3 => save source
c
c  exitCode	- output/integer
c		    0 => success
c		    1 => control/c or some error
c--
#if defined(unix) || HAVE_F77_CPP
#       include "parms.inc"
#elif defined(vms)
	include 'parms.inc'
#endif
c
	character*(l_val) dir_name
	character*(l_val) file_name
	character*132	tempfile
c
 10	if (imod .lt. 1 .or. imod .gt. 3) stop 'Computed goto'
	goto (1000,2000,3000),imod
 1000	call menuTree ('SAVE_ALL',exitCode)
	if (exitCode .ne. 0) goto 9000
c
c  get the names of directory and file
c
	call what_a ('LS','DIR_NAME',0,0,dir_name)
	call what_a ('LS','FILE_NAME',0,0,file_name)
c
c  first the source in file 0
c
C  Notice changes : the source is no longer saved with SAVE SYSTEM command.
C
C	call saveSource (dir_name//file_name,exitCode)
C	if (exitCode .ne. 0) goto 9000
c
c  then the optical elements
c
#ifdef vms
	tempfile = dir_name // file_name
#else
	tempfile = dir_name(1:iblank(dir_name))//'/./'// file_name
#endif
	call saveAllOe (tempfile,exitCode)
	goto 9000
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
 2000	continue
     	call menuTree ('SAVE_OE',exitCode)
	if (exitCode .ne. 0) goto 9000
c
c  get the names of directory and file
c
	call what_a ('LS','DIR_NAME',0,0,dir_name)
	call what_a ('LS','FILE_NAME',0,0,file_name)
	call what_i ('LS','CUR_OE',0,0,cur_oe)
	call what_i ('LS','NEW_OE',0,0,new_oe)
c
c  legal optical element number for file being created
c
	if (new_oe .lt. 1 .or. new_oe .gt. 10) then
	  message='Optical elements must be numbered between 1 and 10'
	  call user_message
	  goto 10
	endif
c
c  optical element exists
c
	call exist (cur_oe,0,iFlag)
	if (iFlag .eq. 0) then
	   write (message,9005) cur_oe
	   call user_message
	   goto 10
	endif
c
#ifdef vms
	tempfile = dir_name // file_name
#else
	tempfile = dir_name(1:iblank(dir_name))//'/./'// file_name
#endif
	call saveOe (tempfile,cur_oe,new_oe,exitCode)
	goto 9000
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
 3000	call menuTree ('SAVE_SOURCE',exitCode)
	if (exitCode .ne. 0) goto 9000
c
c  get the names of directory and file
c
	call what_a ('LS','DIR_NAME',0,0,dir_name)
	call what_a ('LS','FILE_NAME',0,0,file_name)
c
#ifdef vms
	tempfile = dir_name // file_name
#else
	tempfile = dir_name(1:iblank(dir_name))//'/./'// file_name
#endif
	call saveSource (tempfile,exitCode)
	goto 9000
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
 9000	if (exitCode .lt. 0) then
	  message='Unable to save data'
	  if (exitcode .eq. -1) message='File not found'
	  if (exitcode .eq. -2) message='Error opening file'
	  if (exitcode .eq. -3) message='No such device'
	  if (exitcode .eq. -4) message='File name specification error'
	  call user_message
	  goto 10
	endif
c
	return
 9005	format ('Optical element ',i10,' does not exist')
	end
